<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedPrice2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedPrice2 extends AbstractStructArrayBase
{
    /**
     * The ChildrenB
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedPrice[]
     */
    public $ChildrenB;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedPrice2
     * @uses ArrayOfJPSOAP_OrderedPrice2::setChildrenB()
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenB
     */
    public function __construct(array $childrenB = array())
    {
        $this
            ->setChildrenB($childrenB);
    }
    /**
     * Get ChildrenB value
     * @return \StructType\JPSOAP_OrderedPrice[]|null
     */
    public function getChildrenB()
    {
        return $this->ChildrenB;
    }
    /**
     * Set ChildrenB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenB
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice2
     */
    public function setChildrenB(array $childrenB = array())
    {
        foreach ($childrenB as $arrayOfJPSOAP_OrderedPrice2ChildrenBItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedPrice2ChildrenBItem instanceof \StructType\JPSOAP_OrderedPrice) {
                throw new \InvalidArgumentException(sprintf('The ChildrenB property can only contain items of \StructType\JPSOAP_OrderedPrice, "%s" given', is_object($arrayOfJPSOAP_OrderedPrice2ChildrenBItem) ? get_class($arrayOfJPSOAP_OrderedPrice2ChildrenBItem) : gettype($arrayOfJPSOAP_OrderedPrice2ChildrenBItem)), __LINE__);
            }
        }
        $this->ChildrenB = $childrenB;
        return $this;
    }
    /**
     * Add item to ChildrenB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice2
     */
    public function addToChildrenB(\StructType\JPSOAP_OrderedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedPrice) {
            throw new \InvalidArgumentException(sprintf('The ChildrenB property can only contain items of \StructType\JPSOAP_OrderedPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ChildrenB[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildrenB
     */
    public function getAttributeName()
    {
        return 'ChildrenB';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
